
'=========================================================================
'=PLAY requires a string that uses 's music command language.  Some      =
'=of the commands are:                                                   =
'=                                                                       =
'=    A-G  with optional # or -, play the notes A-G with sharps or flats.=
'=    O n  sets the octave.  An octave goes from C to B.                 =
'=           n can range from 0 to 6.                                    =
'=                                                                       =
'=    L n  sets the length of the note. Can range from 1 to 64.          =
'=        Any value, can be played, even 23rd notes!                     =
'=    P n  pauses for length n.                                          =
'=    T n  sets the tempo in quarter notes /minute.  For example         =
'=         Largo is 40-60, Adagio is 66-76, Allegro is 120-168.          =
'=    >    up one octave                                                 =
'=    <    down one octave                                               =
'=To play a sequence, you just construct a string and give it to PLAY.   =
'=                                                                       =
'=       x$ = "efg-fed#"                                                 =
'=       PLAY "T120 L8 o2" + x$ + "p4 o3 l16 " + x$                      =
'=========================================================================


sub play(token as string)
  dim n as short,nt as byte
  dim c as integer,tone as double
  dim s as string,octave as byte
  dim b as string,l as byte
  dim beats as byte
  dim con(6) as short
  con(0)= 0
  con(1)= 2
  con(2)= -9
  con(3)= -7
  con(4)= -5
  con(5)= -4
  con(6)= -2
  octave=6
  beats=120
  l=2:c=0
  token=ucase$(token)
  do
    inc(c)
    nt=asc(char$(token,c))
    if nt>64 and nt<72 then
      'process note
      s=char$(token,c+1)
      if s="#" then inc(nt)
      if s="-" then dec(nt)
      tone=2^(con(nt-65)/12)*440
      tone=tone*2^(octave-4)
      sound tone,l
    else
      if nt=60 then dec(octave)
      if nt=62 then inc(octave)
      if nt=77 then inc(c)
      if nt=76 then
        s=""
        do 
          inc(c)
          b=char$(token,c)
          if b>="0" and b<="9" then
            s=s+char$(token,c)
          else
            dec(c)
            exit do
          end if
        loop
        l=val(s)
        l=(60000/beats)*(l/4)
      end if
      
      if nt=84 then
        s=""
        do 
          inc(c)
          b=char$(token,c)
          if b>="0" and b<="9" then
            s=s+char$(token,c)
          else
            dec(c)
            exit do
          end if
        loop
        beats=val(s)
      end if
      if nt=80 then
        s=""
        do 
          inc(c)
          b=char$(token,c)
          if b>="0" and b<="9" then
            s=s+char$(token,c)
          else
            dec(c)
            exit do
          end if
        loop
        tone=(60000/beats)*(val(s)/4)
        sleep tone
      end if
    end if
  loop until c=>len(token)
end sub

PLAY "MFT110L16C<A#>C<GD#GCP4>C<A#>C<GD#GCP4>CDD#DD#CDCD<A#>C<A#>C<G#>CP4"
PLAY "MFT110L16C<A#>C<GD#GCP4>C<A#>C<GD#GCP4>CDD#DD#CDCD<A#>C<A#>C<G#>CP4"
