
resource bmp as "lc.bmp"

object frm as form
  caption="LC resonance calculator"
  center
  width=300
  onpaint=fpaint
  object l1 as label
    left=20
    top=10
    caption="L:"
    font.bold=true
  end object
  
  object l as edit
    top=8
    left=40
  end object
  object ll as combobox
    left=180
    top=8
    width=50
    ondropdown=getoldval
    onchange=change
    tag=1
    additem("H")
    additem("mH")
    additem("uH")
    itemindex=2
  end object
  object b1 as button
    left=240
    top=6
    width=35
    caption="clear"
    tag=1
    onclick=clear
  end object
  
  object l2 as label
    top=50
    left=20
    caption="C:"
    font.bold=true
  end object
  object c as edit
    top=48
    left=40
  end object
  object lc as combobox
    left=180
    top=48
    width=50
    additem("f")
    additem("mf")
    additem("uf")
    additem("nf")
    additem("pf")
    itemindex=4
    tag=2
    ondropdown=getoldval
    onchange=change
  end object
  
  object b2 as button
    left=240
    top=46
    width=35
    caption="clear"
    tag=2
    onclick=clear
  end object
  
  object l3 as label
    top=90
    left=20
    caption="F:"
    font.bold=true
  end object
  object f as edit
    top=88
    left=40
  end object
  
  object lf1 as combobox
    left=180
    top=88
    width=50
    additem("Hz")
    additem("kHz")
    additem("mHz")
    itemindex=2
    tag=3
    onchange=change
    ondropdown=getoldval
  end object
  
  object b3 as button
    left=240
    top=86
    width=35
    caption="clear"
    tag=3
    onclick=clear
  end object
  
  object but as button
    caption="Calculate"
    top=128
    left=180
    onclick=calculate
  end object
  
end object
frm.showmodal
sub fpaint
  frm.canvas.bmpresource(60,125,bmp)
end sub

sub change(s as combobox)
  dim value as integer
  value=(value-s.itemindex)*-3
  
  select case s.tag
      
    case 1
      
      l.text=str$(val(l.text)*10^value)
      if val(l.text)=0 then l.text=""
    case 2
      
      c.text=str$(val(c.text)*10^value)
      if val(c.text)=0 then c.text=""
    case 3
      
      f.text=str$(val(f.text)*10^-value)
      if val(f.text)=0 then f.text=""
  end select
end sub

sub getoldval(s as combobox)
  change.value=s.itemindex
end sub

sub calculate
  dim cas as word,frequency as double
  dim capicity as double,induction as double
  cas=0
  if l.text<>"" then cas=cas+1
  if c.text<>"" then cas=cas+2
  if f.text<>"" then cas=cas+4
  
  select case cas
      
    case 3
      'calculate f
      induction=val(l.text)*10^(ll.itemindex*-3)   
      capicity=val(c.text)*10^(lc.itemindex*-3)
      f.text=str$(1/(2*pi*sqr(induction*capicity))*10^(lf1.itemindex*-3))
      
    case 5
      'calculate l
      induction=val(l.text)*10^(ll.itemindex*-3)
      frequency=val(f.text)*10^(lf1.itemindex*3)
      c.text=str$(1/((2*pi*frequency)^2*induction*10^(lc.itemindex*-3)))
      
    case 6
      'calculate c
      capicity=val(c.text)*10^(lc.itemindex*-3)
      frequency=val(f.text)*10^(lf1.itemindex*3)
      l.text=str$(1/((2*pi*frequency)^2*capicity*10^(ll.itemindex*-3)))
      
    case 7
      showmessage "Don't know what to calculate."
      
    case else
      showmessage "Not enough parameters."
      
  end select
  
end sub

sub clear(b as button)
  
  select case b.tag
    case 1
      l.text=""
    case 2
      c.text=""
    case 3
      f.text=""
      
  end select
end sub
















